﻿// <auto-generated />
using System;
using Datalaag;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace Datalaag.Migrations
{
    [DbContext(typeof(DataContext))]
    [Migration("20201213194850_InitialCreate")]
    partial class InitialCreate
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.10")
                .HasAnnotation("Relational:MaxIdentifierLength", 64);

            modelBuilder.Entity("Globals.Aanwezigheid", b =>
                {
                    b.Property<int>("RestaurantId")
                        .HasColumnType("int");

                    b.Property<int>("PersoonId")
                        .HasColumnType("int");

                    b.Property<DateTime>("Dag")
                        .HasColumnType("datetime(6)");

                    b.Property<int>("Shift")
                        .HasColumnType("int");

                    b.HasKey("RestaurantId", "PersoonId", "Dag", "Shift");

                    b.HasIndex("PersoonId");

                    b.ToTable("Aanwezigheids");
                });

            modelBuilder.Entity("Globals.Persoon", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<string>("Discriminator")
                        .IsRequired()
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.Property<string>("FamilieNaam")
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.Property<string>("Gemeente")
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.Property<int>("Huisnummer")
                        .HasColumnType("int");

                    b.Property<string>("Land")
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.Property<int>("Postcode")
                        .HasColumnType("int");

                    b.Property<string>("Straat")
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.Property<string>("Telefoonnumeer")
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.Property<string>("Voornaam")
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.HasKey("Id");

                    b.ToTable("Persoon");

                    b.HasDiscriminator<string>("Discriminator").HasValue("Persoon");
                });

            modelBuilder.Entity("Globals.Restaurant", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<int>("AantalSterren")
                        .HasColumnType("int");

                    b.Property<string>("Gemeente")
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.Property<int>("Huisnummer")
                        .HasColumnType("int");

                    b.Property<string>("Naam")
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.Property<int>("Postcode")
                        .HasColumnType("int");

                    b.Property<string>("Stijl")
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.Property<string>("Straat")
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.HasKey("Id");

                    b.ToTable("Restaurants");
                });

            modelBuilder.Entity("Globals.Bezoeker", b =>
                {
                    b.HasBaseType("Globals.Persoon");

                    b.Property<string>("EmailAdres")
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.HasDiscriminator().HasValue("Bezoeker");
                });

            modelBuilder.Entity("Globals.Medewerker", b =>
                {
                    b.HasBaseType("Globals.Persoon");

                    b.Property<int?>("RestaurantId")
                        .HasColumnType("int");

                    b.Property<string>("Rol")
                        .HasColumnType("longtext CHARACTER SET utf8mb4");

                    b.HasIndex("RestaurantId");

                    b.HasDiscriminator().HasValue("Medewerker");
                });

            modelBuilder.Entity("Globals.Aanwezigheid", b =>
                {
                    b.HasOne("Globals.Persoon", "Persoon")
                        .WithMany()
                        .HasForeignKey("PersoonId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Globals.Restaurant", "Restaurant")
                        .WithMany()
                        .HasForeignKey("RestaurantId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Globals.Medewerker", b =>
                {
                    b.HasOne("Globals.Restaurant", "Restaurant")
                        .WithMany()
                        .HasForeignKey("RestaurantId");
                });
#pragma warning restore 612, 618
        }
    }
}
